--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   18:08:13 11/26/2013
-- Design Name:   
-- Module Name:   C:/Users/FJSR/Dropbox/A_CSD/13_14_Q1/EX3/Adder_4bit_serial/Adder_4bit_serial_tb.vhd
-- Project Name:  Adder_4bit_serial_prj
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: Adder_4bit_serial
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY Adder_4bit_serial_tb IS
END Adder_4bit_serial_tb;
 
ARCHITECTURE behavior OF Adder_4bit_serial_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT Adder_4bit_serial
    PORT(
         CLK : IN  std_logic;
         CD : IN  std_logic;
         A : IN  std_logic_vector(3 downto 0);
         B : IN  std_logic_vector(3 downto 0);
         Cin : IN  std_logic;
         ST : IN  std_logic;
         S : OUT  std_logic_vector(3 downto 0);
         Cout : OUT  std_logic;
         EOP : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal CLK : std_logic := '0';
   signal CD : std_logic := '0';
   signal A : std_logic_vector(3 downto 0) := (others => '0');
   signal B : std_logic_vector(3 downto 0) := (others => '0');
   signal Cin : std_logic := '0';
   signal ST : std_logic := '0';

 	--Outputs
   signal S : std_logic_vector(3 downto 0);
   signal Cout : std_logic;
   signal EOP : std_logic;

   -- Clock period definitions
   constant CLK_period : time := 1 us;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: Adder_4bit_serial PORT MAP (
          CLK => CLK,
          CD => CD,
          A => A,
          B => B,
          Cin => Cin,
          ST => ST,
          S => S,
          Cout => Cout,
          EOP => EOP
        );

   -- Clock process definitions
   CLK_process :process
   begin
		CLK <= '0';
		wait for CLK_period/3;
		CLK <= '1';
		wait for 2*CLK_period/3;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for CLK_period*1.43;

	-- Let's start the stimulus activity resetting the system:
		CD <= '1';  	
		wait for CLK_period*3.22;	

		CD <= '0';  	
		wait for CLK_period*2.2;	
      -- insert stimulus here 

		A <= "1101";  			-- data to add
		B <= "0110";  	
		Cin <= '0';  	
		wait for CLK_period*2.22;	
		
		ST <= '1';  			-- start pulse
		wait for CLK_period*12.5;	

		ST <= '0';  	
		wait for CLK_period*4.3;	


		A <= "0101";  			-- data to add
		B <= "0111";  	
		Cin <= '1';  	
		wait for CLK_period*2.22;	

		ST <= '1';  			-- start pulse
		wait for CLK_period*1.5;	

		ST <= '0';  	
		wait for CLK_period*2.2;	


		
      wait;
   end process;

END;
